/* =====================================
// Title ..........: Fibonacciklok
// Author .........: Ed Nieuwenhuys
V001 20 aug 2016 Transferring Fibonacciklok program from Character_Colour_Clock_WS2812_V16 
V005 Installed in Dion en Ed Fibonacci clock. 
V010 28-oct-2016 Version for large 30 x 30 24 hour Fibonacciklok
V011 Several optimizations
V012 05-may-2017 13 hours bug resolved
V013 Code cleanup 
V014 Introduced //#define FIBO12H en //#define FIBO24H to switch between 12 and 24 hour Fibonacci clock. Franse klok verbeterd. Nog niet perfect
V015 Code Clean up.
V016 9 sep 2017 Code Clean up. Klok Ben Bolscher No3
   =====================================*/

//--------------------------------------------
// ARDUINO Definition of installed modules
//--------------------------------------------

#define FIBO12H        // 12 hour fibonacciclock
//#define FIBO24H      // 24 hour fibonacciclock
#define BLUETOOTHMOD
//#define DCFMOD
//#define ROTARYMOD
//#define LCDMOD
//--------------------------------------------
// ARDUINO Definition of installed language word clock
//--------------------------------------------
 #define NL
// #define UK        
// #define DE        
// #define FR        
//--------------------------------------------
// ARDUINO Includes defines and initialysations
//--------------------------------------------
// Get the LCD I2C Library here: 
// https://bitbucket.org/fmalpartida/new-liquidcrystal/downloads
// Move any other LCD libraries to another folder or delete them
// See Library "Docs" folder for possible commands etc.

#include <Wire.h>
                    #ifdef LCDMOD
#include <LCD.h>
#include <LiquidCrystal_I2C.h>
                    #endif  LCDMOD
#include <RTClib.h>
#include <EEPROM.h>
#include "TimeLib.h"
#include <WS2812.h>
                     #ifdef BLUETOOTHMOD
#include <SoftwareSerial.h>     // for Bluetooth communication
                     #endif BLUETOOTHMOD
                     #ifdef ROTARYMOD
#include <Encoder.h>
#ifdef defined(__AVR_ATmega1284P__) || defined(__AVR_ATmega1284__)
  #define CORE_NUM_INTERRUPT 3
  #define CORE_INT0_PIN   10
  #define CORE_INT1_PIN   11
  #define CORE_INT2_PIN   2
 #endif
                     #endif ROTARYMOD
                     #ifdef DCFMOD
#include "DCF77.h"
                     #endif DCFMOD
#ifdef NL
#define HET     Tekstprint("Het ");      
#define IS      Tekstprint("is ");       
#define WAS     Tekstprint("was "); 
#define MVIJF   Tekstprint("vijf ");
#define MTIEN   Tekstprint("tien "); 
#define KWART   Tekstprint("kwart ");
#define VOOR    Tekstprint("voor ");
#define OVER    Tekstprint("over ");

#define PRECIES Tekstprint("precies ");
#define HALF    Tekstprint("half ");
#define ELF     Tekstprint("elf "); 
#define VIJF    Tekstprint("vijf "); 
#define TWEE    Tekstprint("twee ");
#define EEN     Tekstprint("een "); 
#define VIER    Tekstprint("vier "); 
#define TIEN    Tekstprint("tien "); 

#define TWAALF  Tekstprint("twaalf ");  
#define DRIE    Tekstprint("drie ");    
#define NEGEN   Tekstprint("negen ");    
#define ACHT    Tekstprint("acht ");     
#define ZES     Tekstprint("zes ");     
#define ZEVEN   Tekstprint("zeven ");   
#define UUR     Tekstprint("uur ");     
#define EDSOFT  Tekstprint("Edsoft ");   
#endif NL

#ifdef UK
#define HET     Tekstprint("It ");      
#define IS      Tekstprint("is ");     
#define WAS     Tekstprint("was ");    
#define PRECIES Tekstprint("exact ");  
#define HALF    Tekstprint("half ");    
#define TWINTIG Tekstprint("twenty ");
#define MVIJF   Tekstprint("five ");
#define KWART   Tekstprint("quarter ");

#define MTIEN   Tekstprint("ten "); 
#define OVER    Tekstprint("past "); 
#define ZES     Tekstprint("six "); 
#define TWEE    Tekstprint("two "); 
#define VIJF    Tekstprint("five ");  
#define TWAALF  Tekstprint("twelve ");
#define TIEN    Tekstprint("ten "); 
#define ELF     Tekstprint("eleven ");

#define VIER    Tekstprint("four "); 
#define NEGEN   Tekstprint("nine "); 
#define DRIE    Tekstprint("three ");
#define ACHT    Tekstprint("eight ");
#define ZEVEN   Tekstprint("seven "); 
#define EEN     Tekstprint("one ");   
#define UUR     Tekstprint("O'clock ");
#define VOOR    Tekstprint("to ");     
#endif UK

#ifdef FR
#define HET     Tekstprint("Il ");    
#define IS      Tekstprint("est ");   
#define WAS     Tekstprint("etait "); 
#define PRECIES Tekstprint("exact ");
#define ELF     Tekstprint("onze ");  
#define VIJF    Tekstprint("cing ");  
#define TWEE    Tekstprint("deux ");  
#define DRIE    Tekstprint("trois "); 
#define ZES     Tekstprint("six ");   

#define VIER    Tekstprint("quatre ");
#define NTWAALF Tekstprint("minuit ");
#define TIEN    Tekstprint("dix ");   
#define NEGEN   Tekstprint("neuf ");  
#define TWAALF  Tekstprint("midi ");  
#define ACHT    Tekstprint("huit ");  
#define ZEVEN   Tekstprint("sept ");  
#define EEN     Tekstprint("une ");   

#define UUR     Tekstprint("heures ");
#define OVER    Tekstprint("et ");    
#define VOOR    Tekstprint("moins "); 
#define EN      Tekstprint("le ");    
#define KWART   Tekstprint("quart "); 
#define MTIEN   Tekstprint("dix ");   
#define TWINTIG Tekstprint("vingt "); 
#define MVIJF   Tekstprint("cing ");  
#define HALF    Tekstprint("demie "); 
#endif FR


//--------------------------------------------
// PIN Assigments
//-------------------------------------------- 
#if defined(__AVR_ATmega328P__) 
// Digital hardware constants ATMEGA 328 ----
enum DigitalPinAssignments {

 DCF_PIN     =  2,                // DCFPulse on interrupt pin connected to DCF77 module
 encoderPinA  = 3,                // right (labeled DT on decoder)on interrupt  pin
 clearButton  = 4,                // switch (labeled SW on decoder)
 LED_PIN      = 5,                // Pin to control colour 2811/2812 leds
 BT_RX        = 6,                // Bluetooth RX, Connect to Bluetooth TX
 BT_TX        = 7,                // Bluetooth TX, Connect to Bluetooth RX
 encoderPinB  = 8,                // left (labeled CLK on decoder)no interrupt pin 
 EmptyD09     = 9,                // EmptyD09 
 DCF_LED_Pin  = 10,               // pin for LED to display pulse received from DCF77 module
 PWMpin       = 11,               // pin for LED to display intensity read from LDR
 EmptyD10     = 10,               // EmptyD10
 EmptyD11     = 11,               // EmptyD11
 EmptyD12     = 12,               // EmptyD12
 secondsPin   = 13,
 HeartbeatLED = 13};
                                  // Analogue hardware constants ----
enum AnaloguePinAssignments {
 PhotoCellPin  = 2,               // LDR pin
 EmptyA3       = 3,               // EmptyA3
 SDA_pin       = 4,               // SDA pin
 SCL_pin       = 5};              // SCL pin
# endif

//--------------------------------------------//-------------------------------------------- 
#if defined(__AVR_ATmega1284P__) || defined(__AVR_ATmega1284__)
                                  // Digital hardware constants ATMEGA 1284P ----
enum DigitalPinAssignments {
  BT_RX        = 0,               // Bluetooth RX
  BT_TX        = 1,               // Bluetooth TX
  DCF_PIN      = 2,               // DCFPulse on interrupt pin
  PWMpin       = 3,               // Pin that controle PWM signal on BC327 transistor to dim light
  MAX7219_DIN  = 4,               // MAX7219 DIN gr     PB4 PWM
  MAX7219_CS   = 5,               // MAX7219 CS  ge     PB5 digital
  MAX7219_CLK  = 6,               // MAX7219 CLK or     PB6 PWM  
  DS1820Temp   = 7,               // DS1820 temperature PB7 PWM 
  PIN08        = 8,               // RX1                PD0 digital
  PIN09        = 9,               // TX1                PD1 digital
  LED10        = 10,              // LED10              PD2 digital
  encoderPinB  = 11,              // left (labeled CLK on decoder) no interrupt pin  PD3 digital
  encoderPinA  = 12,              // right (labeled DT on decoder) no interrupt pin  PD4 PWM
  clearButton  = 13,              // switch (labeled SW on decoder)                  PD5 PWM
  DCF_LED_Pin  = 14,              // define pin voor DCF signal Led                  PD6 PWM
  HeartbeatLED = 15,              // LED15                                           PD7 PWM
  SCL_pin      = 16,              // SCL pin       PC0 interrupt
  SDA_pin      = 17,              // SDA pin       PC1 interrupt
  PIN18        = 18,              // Empty         PC2 digital
  LED19        = 19,              // LED19         PC3 digital
  LEDDataPin   = 20,              // blauw HC595   PC4 digital
  LEDStrobePin = 21,              // groen HC595   PC5 digital
  LEDClockPin  = 22,              // geel  HC595   PC6 digital
  secondsPin   = 23};              //23             PC7 digital
                                  // Analogue hardware constants ----
enum AnaloguePinAssignments {
  EmptyA0      = 24,              // Empty
  EmptyA1      = 25,              // Empty
  PhotoCellPin = 26,              // LDR pin
  EmptyA3      = 27,              // Empty
  EmptyA4      = 28,              // Empty
  EmptyA5      = 29,              // Empty
  EmptyA6      = 30};             // Empty
 # endif  

//--------------------------------------------
// LED
//--------------------------------------------
                       #ifdef FIBO12H
#define NUM_LEDS    14            // How many leds in  strip?
                       #endif FIBO12H
                       #ifdef FIBO24H
#define NUM_LEDS    117            // How many leds in  strip?
                       #endif FIBO24H
#define BRIGHTNESS  255           // BRIGHTNESS 0 - 255
#define UPDATES_PER_SECOND 20
WS2812  RGBstrip(NUM_LEDS);       // Initialyse RGB strip
byte BrightnessCalcFromLDR = BRIGHTNESS;
int ToggleEdsoft = 1;             // flash led every hour
uint32_t MINColor      = 0XFFDD00;
uint32_t SECColor      = 0XFFDD00;
uint32_t Color         = 0XFFDD00;
uint32_t DefaultColor  = 0XFFDD00;         // Geel
uint32_t WhiteColour   = 0XFFFFFF;
uint32_t HourColor[24] ={0XFFFFFF,0X5EFF00,0XFFD500,0X00E6FF,0XFF6200,0X88FF88,
                     0XAE00FF,0X00C8FF,0X660099,0XFFD000,0X00FF00,0XFF0050,
                     0XFF0000,0XFFFF00,0XFF4000,0XFF0088,0XF7FF00,0XFF00BF,
                     0X00FF00,0X00F2A0,0X6FFF00,0X0073FF,0XF200FF,0X0000FF };
                   
//--------------------------------------------
// KY-040 ROTARY
//-------------------------------------------- 
                          #ifdef ROTARYMOD                         
Encoder myEnc(encoderPinA, encoderPinB);              // Use digital pin  for encoder
                         #endif ROTARYMOD      
long Looptime = 0;
unsigned long RotaryPressTimer = 0;

//--------------------------------------------
// LDR PHOTOCELL
//--------------------------------------------
float LightReducer   = 1.00 ;     // Factor to dim ledintensity with. Between 0.1 and 1 in steps of 0.05
byte LowerBrightness = 10;        // Lower limit of Brightness ( 0 - 255)
int OutPhotocell;                 // stores reading of photocell;
int MinPhotocell     = 1024;      // stores minimum reading of photocell;
int MaxPhotocell     = 1;         // stores maximum reading of photocell;

//--------------------------------------------
// CLOCK
//--------------------------------------------                                 
#define MAXTEXT 50
static unsigned long msTick;   // the number of millisecond ticks since we last incremented the second counter
int  count; 
int  Delaytime          = 200;
byte Isecond, Iminute, Ihour, Iday, Imonth, Iyear; 
byte lastminute = 0, lasthour = 0, sayhour = 0;
byte Toggle_HetWasIs    = 1;      // Turn On/Off HetIsWas lights
byte Toggle_HetWasIsUit = 0;      // Turn off HetIsWas after 10 sec
byte SecPulse           = 0;      // give a pulse to the Isecond led
byte Demo               = false;  // true;
String SerialString;
byte hbval = 128;
byte hbdelta = 8;
byte Is = true;                   // toggle of displaying Is or Was
char sptext[MAXTEXT+2];           // for common print use

//--------------------------------------------
// DS3231 CLOCK MODULE
//--------------------------------------------
#define DS3231_I2C_ADDRESS          0x68
#define DS3231_TEMPERATURE_MSB      0x11
#define DS3231_TEMPERATURE_LSB      0x12
RTC_DS3231 RTC;    //RTC_DS1307 RTC;  
DateTime Inow;

//--------------------------------------------
// BLUETOOTH
//--------------------------------------------                                     
#ifdef BLUETOOTHMOD               // Bluetooth ---------------------
SoftwareSerial Bluetooth(BT_RX, BT_TX);    // RX, TX
String BluetoothString;
#endif BLUETOOTHMOD 

//--------------------------------------------
// DCF-2 DCF77 MODULE
//--------------------------------------------
byte DCF_signal = 0;              // is a proper time received?
#ifdef DCFMOD                     // DCF77 ------------------------------
#if defined(__AVR_ATmega328P__) 
#define DCF_INTERRUPT 0           // DCF Interrupt number associated with DCF_PIN
#endif
#if defined(__AVR_ATmega1284P__) || defined(__AVR_ATmega1284__)
#define DCF_INTERRUPT 2           // DCF Interrupt number associated with DCF_PIN
#endif
time_t tijd;
DCF77 DCF = DCF77(DCF_PIN,DCF_INTERRUPT,LOW);
#endif DCFMOD 
                    #ifdef LCDMOD
//--------------------------------------------
// LCD Module
//--------------------------------------------
LiquidCrystal_I2C lcd(0x27,2,1,0,4,5,6,7); // 0x27 is the I2C bus address for an unmodified backpack
                    #endif 
                                 
//--------------------------------------------
// COLOURS
//--------------------------------------------   
#define DEFAULTCOLOUR  0
#define HOURLYCOLOUR   1           
#define NOFUSSCOLOUR   2
#define DEMOCOLOUR     3
//byte DisplayChoice = DEFAULTCOLOUR;
//byte DisplayChoice = NOFUSSCOLOUR;
//byte DisplayChoice = DEMOCOLOUR;
byte DisplayChoice = HOURLYCOLOUR;


                     #ifdef FIBO12H 
#define CLOCK_PIXELS 5                            // Number of cells in clock = 5 (1,1,2,3,5)
                     #endif FIBO12H
                     #ifdef FIBO24H 
#define CLOCK_PIXELS 7                            // Number of cells in clock = 7 (1,1,2,3,5,8,13)
                     #endif FIBO24H
#define TOTAL_PALETTES 10
byte DisplayPalette = 1;                          // palette to display 1 = Mondriaan
byte bits[CLOCK_PIXELS+1];
byte BitSet[CLOCK_PIXELS+1];
uint32_t black = 0x000000; 
uint32_t colors[TOTAL_PALETTES][4] = 
  {  //  off     hours     minutes   both;
    { 0xF0D000, 0xFF0A0A, 0x0AFF0A, 0x0A0AFF },  // #0 RGB  
    { 0xFFFFFF, 0xFF0A0A, 0xF0D000, 0x0A0AFF },  // #1 Mondriaan
    { 0xFFFFFF, 0x502800, 0x14C014, 0xFF640A },  // #2 Basbrun 
    { 0xFFFFFF, 0xF564C9, 0x72F736, 0x71EBDB },  // #3 80's
    { 0xFFFFFF, 0xFF7B7B, 0x8FFF70, 0x7878FF },  // #4 Pastel
    { 0xFFFFFF, 0xD4312D, 0x91D231, 0x8D5FE0 },  // #5 Modern
    { 0xFFFFFF, 0xD13EC8, 0x45E8E0, 0x5046CA },  // #6 Cold
    { 0xFFFFFF, 0xED1414, 0xF6F336, 0xFF7E15 },  // #7 Warm
    { 0xFFFFFF, 0x462300, 0x467A0A, 0xC8B600 },  // #8 Earth
    { 0xFFFFFF, 0x0A0AFF, 0xFF0A0A, 0xF0D000 }} ;// #9 Mondriaan1
 // { 0x502800, 0xD32222, 0x50974E, 0x101895 } };// #9 Dark 

 // End Definitions  ---------------------------------------------------------

void SWversion(void) 
{ 
 for (int n=0; n<80;n++) {Serial.print(F("="));} Serial.println();
 Serial.println(F("Fibonacci_Colour_Clock_WS2812_1284-328-V016 met Rotary KY-040, Temp, Bluetooth, DCF77"));
 Tekstprintln("\nFibonacciklok");
 Tekstprintln("\nEnter Time as: hhmm (1321) or hhmmss (132145)");
 Tekstprintln("D for Demo mode");
 Tekstprintln("Mnn (M90) light intensity (1%-250%)");
 Tekstprintln("Lnn (L5) lowest intensity (1-255)");
 Tekstprintln("Pn  (P1) to select a palette (0-9)");
 Tekstprintln("I for info");
 Tekstprintln("Ed Nieuwenhuys");
 sprintf(sptext,"Max brightness: %3ld%%",(long)(LightReducer*100)) ;
 Tekstprintln(sptext);
 sprintf(sptext,"Lower brightness: %3ld bits",(long) LowerBrightness);
 Tekstprintln(sptext);
 for (int n=0; n<80;n++) {Serial.print(F("="));} Serial.println();
 GetTijd(1);
}
//--------------------------------------------
// ARDUINO Loop
//--------------------------------------------
void loop(void)
{
SerialCheck();
 
 if(Demo)  Demomode();
 else
  { 
                              #if defined(__AVR_ATmega1284P__) || defined(__AVR_ATmega1284__)
  heartbeat();                // only heartbeat with ATMEGA1284
                              #endif

  EverySecondCheck();
  EveryMinuteUpdate();
                              #ifdef FMRADIOMOD     
  FMradioCheck();  
                              #endif FMRADIOMOD
                              #ifdef BLUETOOTHMOD   
  BluetoothCheck(); 
                              #endif BLUETOOTHMOD
                              #ifdef DCFMOD         
  DCF77Check();
                              #endif DCFMOD

                              #ifdef ROTARYMOD      
  RotaryEncoderCheck(); 
                              #endif ROTARYMOD 
 }
}  
//--------------------------------------------
// ARDUINO Setup
//--------------------------------------------
void setup()
{                                              // initialise the hardware // initialize the appropriate pins as outputs:                                          
 pinMode(DCF_LED_Pin,  OUTPUT);
 pinMode(PWMpin,  OUTPUT);
 pinMode(secondsPin,   OUTPUT );
 pinMode(encoderPinA,  INPUT_PULLUP);
 pinMode(encoderPinB,  INPUT_PULLUP);  
 pinMode(clearButton,  INPUT_PULLUP);
 pinMode(DCF_PIN,      INPUT_PULLUP);
 RGBstrip.setOutput(LED_PIN);                  // Set strip dat output to pin LED pin
 RGBstrip.sync();                              // Initialize all pixels to 'off'
 RGBstrip.setBrightness(BRIGHTNESS);  
 Serial.begin(9600);                          // setup the serial port to 9600 baud 
 Wire.begin();                                // start the wire communication I2C
 RTC.begin();                                 // start the RTC-module
                          #ifdef BLUETOOTHMOD 
 Bluetooth.begin(9600);                       // setup the Bluetooth port to 9600 baud 
                          #endif BLUETOOTHMOD
                          #ifdef DCFMOD
 DCF.Start();                                 // start the DCF-module
                          #endif DCFMOD
 analogWrite(PWMpin, BrightnessCalcFromLDR);  // the duty cycle: between 0 (lights off) and 255 (light full on).  
                          #ifdef LCDMOD
 lcd.begin (16,2); // for 16 x 2 LCD module   // activate LCD module
 lcd.setBacklightPin(3,POSITIVE);
 lcd.setBacklight(HIGH);
                          #endif LCDMOD
 DateTime now = RTC.now();
 DateTime compiled = DateTime(__DATE__, __TIME__);
 if (now.unixtime() < compiled.unixtime()) 
  {
   Serial.println(F("RTC is older than compile time! Updating"));  // following line sets the RTC to the date & time this sketch was compiled
   RTC.adjust(DateTime(F(__DATE__), F(__TIME__))); 
  }
 if (EEPROM.read(0) <3 || EEPROM.read(0) > 200) 
   EEPROM.write(0,(int)(LightReducer * 100));                      // default intensity for this clock
 if (EEPROM.read(1) <1 || EEPROM.read(1) > 100) 
   EEPROM.write(1, LowerBrightness);                               // default Lower Brightness for this clock
 LightReducer = ((float) EEPROM.read(0) / 100);                    // store it is the work variable
 LowerBrightness = EEPROM.read(1);                                 // store it is the work variable
 Looptime = millis();                                              // Used in KY-040 rotary
 msTick = millis(); 
 SWversion();                                                      // Display the version number of the software
//Selftest();                                                       // Play the selftest
 GetTijd(0);                                                       // Get the time and print it to serial
 } 

//--------------------------------------------
// CLOCK Demo mode
//--------------------------------------------
void Demomode(void)
{

  if ( millis() - msTick >50)   digitalWrite(secondsPin,LOW);       // Turn OFF the second on pin 13
  if ( millis() - msTick >999)                                      // Flash the onboard Pin 13 Led so we know something is happening
  {    
   msTick = millis();                                               // second++; 
   digitalWrite(secondsPin,HIGH);                                   // turn ON the second on pin 13
   ++SecPulse;                                                      // second routine in function DimLeds
   if (++Iminute >59) { Iminute = 0; Isecond = 0; Ihour++;}
   if (    Ihour >23)  Ihour = 0;
   DimLeds(false);
                          #ifdef BLUETOOTHMOD
   BluetoothCheck();
                          #endif BLUETOOTHMOD
   Displaytime();
  }
}

//--------------------------------------------
// CLOCK common print routines
//--------------------------------------------
void Tekstprint(char tekst[])
{
 Serial.print(tekst);    
                          #ifdef BLUETOOTHMOD   
 Bluetooth.print(tekst);  
                          #endif BLUETOOTHMOD
}
void Tekstprintln(char tekst[])
{
 Serial.println(tekst);    
                          #ifdef BLUETOOTHMOD
 Bluetooth.println(tekst);
                          #endif BLUETOOTHMOD
}
//--------------------------------------------
// CLOCK Update routine done every second
//--------------------------------------------
void EverySecondCheck(void)
{
  if ( millis() - msTick >50)   digitalWrite(secondsPin,LOW);       // Turn OFF the second on pin 13
  if ( millis() - msTick >999)                                      // Flash the onboard Pin 13 Led so we know something is happening
  {    
   msTick = millis();                                               // second++; 
   digitalWrite(secondsPin,HIGH);                                   // turn ON the second on pin 13
   ++SecPulse;                                                      // second routine in function DimLeds
   GetTijd(0);                                                      // synchronize time with RTC clock
                    #ifdef LCDMOD
   Print_tijd_LCD();
                    #endif LCDMOD  
   if ((Toggle_HetWasIsUit == 2) && (Isecond > 10)) Toggle_HetWasIs = 0; 
    else Toggle_HetWasIs = 1;                                       // HET IS WAS is On
   if(Isecond % 30 == 0) DimLeds(true);                             //Led Intensity Control + seconds tick print every 30 seconds   
    else                 DimLeds(false);
  if ((Toggle_HetWasIsUit == 2) && (Isecond == 11))Displaytime();   // turn Leds OFF on second == 11

  if(Iminute == 0 && Isecond <9)
   { 
    ToggleEdsoft = Isecond % 2;                                     // ToggleEdsoft bocomes 0 or 1 and turn on and off the first seconds at minute 0 the Edsoft light on pin 24
    Serial.println(ToggleEdsoft);
    Displaytime();                                                  // --- dit moet iets laten knipperen
   }
  }
 }

//--------------------------------------------
// CLOCK Update routine done every minute
//--------------------------------------------
 void EveryMinuteUpdate(void)
 {
 if (Iminute != lastminute)                                         //show time every minute
  { 
   lastminute = Iminute;
   Displaytime();
//   Print_RTC_tijd();
  } 
 if (Ihour != lasthour) {lasthour = Ihour;}
 if (DCF_signal >2) DCF_signal = 0;                                 // DCF_signal lost
 }
                            #ifdef BLUETOOTHMOD
//--------------------------------------------
// CLOCK check for Bluetooth input
//--------------------------------------------                           
void BluetoothCheck(void)
{ 
 while (Bluetooth.available())
  {
   delay(3); 
   char c = Bluetooth.read();
   if (c>31 && c<128) { BluetoothString += c;    }   
  }
 if (BluetoothString.length()>0)  ReworkInputString(BluetoothString); // Rework ReworkInputString();
 BluetoothString = "";
}
                           #endif BLUETOOTHMOD                           
                           #ifdef DCFMOD
//--------------------------------------------
// CLOCK check for DCF input
//--------------------------------------------
void DCF77Check(void)
{
  time_t DCFtime = DCF.getTime();                                   // Check if new DCF77 time is available
  if (DCFtime!=0)
   {
    Serial.print(F("Time is updated ----->  "));
    DCF_signal++;
    setTime(DCFtime); 
    RTC.adjust(DCFtime);
    digitalClockDisplay(); 
   } 
  digitalWrite(DCF_LED_Pin,1-digitalRead(DCF_PIN));                // write inverted DCF pulse to LED on board
} 
                           #endif DCFMOD 
//--------------------------------------------
// CLOCK check for serial input
//--------------------------------------------
void SerialCheck(void)
{
 while (Serial.available())
  {
   delay(3);  
   char c = Serial.read();
   if (c>31 && c<128) SerialString += c;                            // allow input from Space - Del
  }
 if (SerialString.length()>0)     ReworkInputString(SerialString);  // Rework ReworkInputString();
 SerialString = "";
}

//--------------------------------------------
// CLOCK heartbeat
//--------------------------------------------
void heartbeat() 
{
  static unsigned long last_time = 0;
  unsigned long now = millis();
  if ((now - last_time) < 40)    return;
  last_time = now;
  if (hbval > 230 || hbval < 20 ) hbdelta = -hbdelta; 
  hbval += hbdelta;
  analogWrite(HeartbeatLED, hbval);
}

//------------------------ KY-040 rotary encoder ------------------------- 
//--------------------------------------------
// KY-040 ROTARY check if the rotary is moving
//--------------------------------------------
                           #ifdef ROTARYMOD
void RotaryEncoderCheck(void)
{
// If button pressed, 60 sec after start ATMEGA, then there are 60 seconds to adjust the light intensity. 
// RotaryPressTimer is the time in millisec after start ATMEGA 
 long encoderPos = myEnc.read();
 if ( (encoderPos) && ( (millis() - Looptime) >500))                 // if rotary turned debounce 0.5 sec
  {   
   Serial.print(F("--------> Index:"));   Serial.println(encoderPos);
   if  (encoderPos >0)                                               // increase the MINUTES
    {
     if ( millis() > 60000 && (millis() - RotaryPressTimer) < 60000)
         { WriteLightReducer(0.05); }                                // If time < 60 sec then adjust light intensity factor
     else 
     {
      if( ++Iminute >59) { Iminute = 0; Isecond = 0;  }
      SetRTCTime();  
     }     
     myEnc.write(0);
     Looptime = millis();                                            // Set encoder pos back to 0
    }
   if  (encoderPos <0)                                               // increase the HOURS
    {
     if (millis() > 60000 &&  (millis() - RotaryPressTimer) < 60000) 
         { WriteLightReducer(-0.05); }    // If time < 60 sec then adjust light intensity factor
     else
      { 
      if( ++Ihour >23) { Ihour = 0; }
      SetRTCTime();   
      }
     myEnc.write(0);
     Looptime = millis();                                            // Set encoder pos back to 0      
    }                                                
  }
 if (digitalRead(clearButton) == LOW )                               // set the time by pressing rotary button
  { 
    delay(200);
    RotaryPressTimer =  millis();                                    // If time < 60 sec then adjust light intensity factor
    Toggle_HetWasIsUit++;
    if (Toggle_HetWasIsUit >= 3)  { Toggle_HetWasIsUit = 0 ; }
    if (Toggle_HetWasIsUit == 0)  { Toggle_HetWasIs = 1;} // On
    if (Toggle_HetWasIsUit == 1)  { Toggle_HetWasIs = 0;} // Off
    if (Toggle_HetWasIsUit == 2)  { Toggle_HetWasIs = 0; Play_Lights(); } // Off after 10 sec
    Serial.print(F("Toggle_HetWasIsUit: "));   Serial.println(Toggle_HetWasIsUit);
    Serial.print(F("Toggle_HetWasIs: "));      Serial.println(Toggle_HetWasIs);    
    Displaytime();
    myEnc.write(0);
    Looptime = millis(); 
   }
 }
                           #endif ROTARYMOD
//--------------------------------------------
// CLOCK Self test sequence
//--------------------------------------------
void Selftest(void)
{
  
 //  Serial.print(F("Self test in : "));
 // start by clearing the display to a known state
//  GetTijd(1); //Prints time in Serial monitor
//  LedsOff(); 
//  HET;     Laatzien();
//  IS;      Laatzien();
//  WAS;     Laatzien();
//  MVIJF;   Laatzien();
//  MTIEN;   Laatzien();
//  KWART;   Laatzien(); 
//  VOOR;    Laatzien();
//  OVER;    Laatzien();
//  PRECIES; Laatzien(); 
//  HALF;    Laatzien();
//  ELF;     Laatzien();  
//  VIJF;    Laatzien();
//  TWEE;    Laatzien();  
//  EEN;     Laatzien(); 
//  VIER;    Laatzien();
//  TIEN;    Laatzien();
//  TWAALF;  Laatzien();
//  DRIE;    Laatzien();
//  NEGEN;   Laatzien(); 
//  ACHT;    Laatzien();
//  ZES;     Laatzien(); 
//  ZEVEN;   Laatzien();  
//  UUR;     Laatzien();
//// EDSOFT;  Laatzien();
//   
//  Play_Lights();     
//  Displaytime();

 for(int n=0; n<25; n++)
 {
 for(int i=0; i<NUM_LEDS; i++)     
   {
    RGBstrip.setHSV(i,n*10,255,255);
    WriteLEDs();
   }
  delay(20);
 }
 ColourLeds(0,NUM_LEDS-1,0xFFFFFF); 
 WriteLEDs();
 delay(10);
}
// -------------------------- End Selftest

//--------------------------------------------
// FIBONACCI Set the color and strip based on the time
//--------------------------------------------
void LEDsetTime(byte hours, byte minutes)
{ 
                    #ifdef FIBO12H
 hours %=12;                                         // keep the hours between 0 and 12
                    #endif FIBO12H
 for(int i=0; i<CLOCK_PIXELS; i++) { bits[i] = 0; BitSet[i] = 0; } // clear all bits  
 MakeFibonacciList(hours);
 for(int i=0; i<CLOCK_PIXELS; i++)   if(BitSet[i]) bits[i] +=1;  
 for(int i=0; i<CLOCK_PIXELS; i++)   BitSet[i] = 0;  // clear  bits  
                     #ifdef FIBO12H 
 MakeFibonacciList(minutes/5);                       // if 12 hour clock minutes block is 5 minutes
                     #endif FIBO12H
                     #ifdef FIBO24H
 MakeFibonacciList(minutes/2);                       // if 24 hour clock minutes block is 2 minutes
                     #endif FIBO24H                    
 for(int i=0; i<CLOCK_PIXELS; i++)  
 {
   if( BitSet[i]) bits[i] +=2;    
   setPixel(i, colors[DisplayPalette][bits[i]]);  
// Serial.println(colors[DisplayPalette][bits[i]],HEX);
  }
}

//--------------------------------------------
// FIBONACCI Calculate the proper Fibonacci-numbers (Pixels)
//--------------------------------------------
void MakeFibonacciList(byte Value)
{
byte CalcValue = 0;
while (Value != CalcValue  )
 {
  byte Fibonaccireeks[] = {1,1,2,3,5,8,13,0};        // set up Fibonacci array with 7 numbers.
  for(int i=0; i<=CLOCK_PIXELS; i++) BitSet[i] = 0;  // clear all bits. NB CLOCK_PIXELS is noof cells / strips in the clock
  CalcValue = 0;
  byte pos = CLOCK_PIXELS;
  while ( (Value != CalcValue) &&  CalcValue <=  Value)   
   {
    do { pos = random(CLOCK_PIXELS); }    while (Fibonaccireeks[pos] == 0 );   
    CalcValue += Fibonaccireeks[pos];
    BitSet[pos] = 1;                                 // set pos in array for valid number    
    Fibonaccireeks[pos] = 0;                         // number taken from array 
   }
 }
}

//--------------------------------------------
// FIBONACCI Turn on the right pixels and colours for 24 hour 
//--------------------------------------------
void setPixel(byte pixel, uint32_t kleur)
{  
                #ifdef FIBO12H
    switch(pixel)
  {
    case 0:      ColourLeds(0,1,kleur);       break;
    case 1:      ColourLeds(1,2,kleur);       break;
    case 2:      ColourLeds(2,3,kleur);       break;
    case 3:      ColourLeds(4,7,kleur);       break;
    case 4:      ColourLeds(8,13,kleur);      break;   
  };
                  #endif FIBO12H
                  #ifdef FIBO24H  
  switch(pixel)
  {
    case 0:      ColourLeds(0,3,kleur);       break;
    case 1:      ColourLeds(4,7,kleur);       break;
    case 2:      ColourLeds(8,15,kleur);      break;
    case 3:      ColourLeds(16,27,kleur);     break;
    case 4:      ColourLeds(28,43,kleur);     break;
    case 5:      ColourLeds(44,71,kleur);     break;
    case 6:      ColourLeds(72,116,kleur);    break;      
  };
                    #endif FIBO24H
}

//--------------------------- Time functions --------------------------
//--------------------------------------------
// CLOCK Self test sequence
//--------------------------------------------
void Displaytime(void)
{
 CheckColourStatus();                          // Check colours to display as chosen by toggle rotary switch        
//LedsOff();                                  // Start by clearing the display to a known state
LEDsetTime(Ihour , Iminute);                  // Fibonacci clock
WriteLEDs();

 HET;                                         // HET light is always on
 switch (Iminute)
 {
#ifdef NL
  case  0: IS;  PRECIES; break;
  case  1: IS;  break;
  case  2: 
  case  3: WAS; break;
  case  4: 
  case  5: 
  case  6: IS;  MVIJF; OVER; break;
  case  7: 
  case  8: WAS; MVIJF; OVER; break;
  case  9: 
  case 10: 
  case 11: IS;  MTIEN; OVER; break;
  case 12: 
  case 13: WAS; MTIEN; OVER; break;
  case 14: 
  case 15: 
  case 16: IS;  KWART; OVER; break;
  case 17: 
  case 18: WAS; KWART; OVER; break;
  case 19: 
  case 20: 
  case 21: IS;  MTIEN; VOOR; HALF; break;
  case 22: 
  case 23: WAS; MTIEN; VOOR; HALF; break;
  case 24: 
  case 25: 
  case 26: IS;  MVIJF; VOOR; HALF; break;
  case 27: 
  case 28: WAS; MVIJF; VOOR; HALF; break;
  case 29: IS;  HALF; break;
  case 30: IS;  PRECIES; HALF; break;
  case 31: IS;  HALF; break;
  case 32: 
  case 33: WAS; HALF; break;
  case 34: 
  case 35: 
  case 36: IS;  MVIJF; OVER; HALF; break;
  case 37: 
  case 38: WAS; MVIJF; OVER; HALF; break;
  case 39: 
  case 40: 
  case 41: IS;  MTIEN; OVER; HALF; break;
  case 42: 
  case 43: WAS; MTIEN; OVER; HALF; break;
  case 44: 
  case 45: 
  case 46: IS;  KWART; VOOR; break;
  case 47: 
  case 48: WAS; KWART; VOOR; break;
  case 49: 
  case 50: 
  case 51: IS;  MTIEN; VOOR;  break;
  case 52: 
  case 53: WAS; MTIEN; VOOR;  break;
  case 54: 
  case 55: 
  case 56: IS;  MVIJF; VOOR; break;
  case 57: 
  case 58: WAS; MVIJF; VOOR; break;
  case 59: IS;  break;
#endif NL

#ifdef UK
  case  0: IS;  PRECIES; break;
  case  1: IS;  break;
  case  2: 
  case  3: WAS; break;
  case  4: 
  case  5: 
  case  6: IS;  MVIJF; OVER; break;
  case  7: 
  case  8: WAS; MVIJF; OVER; break;
  case  9: 
  case 10: 
  case 11: IS;  MTIEN; OVER; break;
  case 12: 
  case 13: WAS; MTIEN; OVER; break;
  case 14: 
  case 15: 
  case 16: IS;  KWART; OVER; break;
  case 17: 
  case 18: WAS; KWART; OVER; break;
  case 19: 
  case 20: 
  case 21: IS;  TWINTIG; OVER;  break;
  case 22: 
  case 23: WAS; TWINTIG; OVER; break;
  case 24: 
  case 25: 
  case 26: IS;  TWINTIG; MVIJF; OVER; break;
  case 27: 
  case 28: WAS; TWINTIG; MVIJF; OVER; break;
  case 29: IS;  HALF; OVER; break;
  case 30: IS;  PRECIES; HALF; OVER; break;
  case 31: IS;  HALF; OVER; break;
  case 32: 
  case 33: WAS; HALF; OVER; break;
  case 34: 
  case 35: 
  case 36: IS;  TWINTIG; MVIJF; VOOR; break;
  case 37: 
  case 38: WAS; TWINTIG; MVIJF; VOOR; break;
  case 39: 
  case 40: 
  case 41: IS;  TWINTIG; VOOR;  break;
  case 42: 
  case 43: WAS; TWINTIG; VOOR;  break;
  case 44: 
  case 45: 
  case 46: IS;  KWART; VOOR; break;
  case 47: 
  case 48: WAS; KWART; VOOR; break;
  case 49: 
  case 50: 
  case 51: IS;  MTIEN; VOOR;  break;
  case 52: 
  case 53: WAS; MTIEN; VOOR;  break;
  case 54: 
  case 55: 
  case 56: IS;  MVIJF; VOOR; break;
  case 57: 
  case 58: WAS; MVIJF; VOOR; break;
  case 59: IS;  break;
#endif UK

 
#ifdef FR
  case  0: IS;  PRECIES; break;
  case  1: IS;  break;
  case  2: 
  case  3: WAS; break;
  case  4: 
  case  5: 
  case  6: IS;  MVIJF; OVER; break;
  case  7: 
  case  8: WAS; MVIJF; OVER; break;
  case  9: 
  case 10: 
  case 11: IS;  MTIEN; OVER; break;
  case 12: 
  case 13: WAS; MTIEN; OVER; break;
  case 14: 
  case 15: 
  case 16: IS;  KWART; OVER; break;
  case 17: 
  case 18: WAS; KWART; OVER; break;
  case 19: 
  case 20: 
  case 21: IS;  TWINTIG; OVER;  break;
  case 22: 
  case 23: WAS; TWINTIG; OVER; break;
  case 24: 
  case 25: 
  case 26: IS;  TWINTIG; MVIJF; OVER; break;
  case 27: 
  case 28: WAS; TWINTIG; MVIJF; OVER; break;
  case 29: IS;  HALF; OVER; break;
  case 30: IS;  PRECIES; HALF; OVER; break;
  case 31: IS;  HALF; OVER; break;
  case 32: 
  case 33: WAS; HALF; OVER; break;
  case 34: 
  case 35: 
  case 36: IS;  TWINTIG; MVIJF; VOOR; break;
  case 37: 
  case 38: WAS; TWINTIG; MVIJF; VOOR; break;
  case 39: 
  case 40: 
  case 41: IS;  TWINTIG; VOOR;  break;
  case 42: 
  case 43: WAS; TWINTIG; VOOR;  break;
  case 44: 
  case 45: 
  case 46: IS;  KWART; VOOR; break;
  case 47: 
  case 48: WAS; KWART; VOOR; break;
  case 49: 
  case 50: 
  case 51: IS;  MTIEN; VOOR;  break;
  case 52: 
  case 53: WAS; MTIEN; VOOR;  break;
  case 54: 
  case 55: 
  case 56: IS;  MVIJF; VOOR; break;
  case 57: 
  case 58: WAS; MVIJF; VOOR; break;
  case 59: IS;  break;
#endif FR
}
// if (Ihour >=0 && Ihour <12) digitalWrite(DCF_LED_Pin,0); else digitalWrite(DCF_LED_Pin,1);
                                        #ifdef NL
 sayhour = Ihour;
 if (Iminute > 18 )  sayhour = Ihour+1;
 if (sayhour >= 24) sayhour = 0;
                                        #endif NL
                                        #ifdef UK
 sayhour = Ihour;
 if (Iminute > 33 )  sayhour = Ihour+1;
 if (sayhour == 24) sayhour = 0;
                                        #endif UK

                                        #ifdef FR
 sayhour = Ihour;                                   // French saying still not perfect
 if (Iminute > 33 )  sayhour = Ihour+1;
 if (sayhour == 24) sayhour = 0;
                                        #endif FR
 
 switch (sayhour)
  {
  case 13:
  case 1: EEN; break;
  case 14:
  case 2: TWEE; break;
  case 15:
  case 3: DRIE; break;
  case 16:
  case 4: VIER; break;
  case 17:
  case 5: VIJF; break;
  case 18:
  case 6: ZES; break;
  case 19:
  case 7: ZEVEN; break;
  case 20:
  case 8: ACHT; break;
  case 21:
  case 9: NEGEN; break;
  case 22:
  case 10: TIEN; break;
  case 23:
  case 11: ELF; break;
  case 0:
  case 12: TWAALF; break;
  } 
 switch (Iminute)
  {
  case 59: 
  case  0: 
  case  1: 
  case  2: 
  case  3: UUR;  break; 
  }
 if(Iminute == 0 && Isecond <9) 
 { 
  ToggleEdsoft = Isecond % 2;         // ToggleEdsoft bocomes 0 or 1 and turn on and off the first 8 seconds at minute 0 the Edsoft light on pin 24
 // EDSOFT;
 } 
 Tekstprintln("");
// WriteLEDs();
}

//--------------------------------------------
// DS3231 Get time from DS3231
//--------------------------------------------
void GetTijd(byte printit)
{
 Inow =    RTC.now();
 Ihour =   Inow.hour();
 Iminute = Inow.minute();
 Isecond = Inow.second();
// if (Ihour > 24) { Ihour = random(12)+1; Iminute = random(60)+1; Isecond = 30;}  // set a time if time module is absent or defect
 if (printit)  Print_RTC_tijd(); 
}

//--------------------------------------------
// DS3231 utility function prints time to serial
//--------------------------------------------
void Print_RTC_tijd(void)
{
 sprintf(sptext,"%0.2d:%0.2d:%0.2d %0.2d-%0.2d-%0.4d",Inow.hour(),Inow.minute(),Inow.second(),Inow.day(),Inow.month(),Inow.year());
 Tekstprintln(sptext);
}
                    #ifdef LCDMOD
//--------------------------------------------
// CLOCK Print time to LCD display
//--------------------------------------------
void Print_tijd_LCD(void)
{
 lcd.home (); // set cursor to 0,0
 if (Inow.hour() < 10) lcd.print(F("0"));
 lcd.print(Inow.hour(), DEC);
 lcd.print(F(":"));
 if (Inow.minute() < 10) lcd.print(F("0"));
 lcd.print(Inow.minute(), DEC);
 lcd.print(F(":"));
 if (Inow.second() < 10) lcd.print(F("0"));
 lcd.print(Inow.second(), DEC);
 lcd.print(F(" LDR"));
 lcd.print(analogRead(PhotoCellPin));
 lcd.print(F("    "));
 lcd.setCursor (0,1);        // go to start of 2nd line
 if (Inow.day() < 10) lcd.print(F("0"));
 lcd.print(Inow.day(), DEC);
 lcd.print(F("/"));
 if (Inow.month() < 10) lcd.print(F("0"));
 lcd.print(Inow.month(), DEC);
 lcd.print(F("/"));
 lcd.print(Inow.year(), DEC); 
 if (DCF_signal>0) {lcd.print(F(" DCF"));lcd.print(DCF_signal); }
 else lcd.print(F("   .  ")); 
}
                    #endif LCDMOD
//--------------------------------------------
// CLOCK utility function prints time to serial
//--------------------------------------------
void Print_tijd(void)
{
  sprintf(sptext,"%0.2d:%0.2d:%0.2d",Ihour,Iminute,Isecond);
 Tekstprintln(sptext);
}
                         #ifdef DCFMOD
//--------------------------------------------
// DCF77 utility function prints DCF time
//--------------------------------------------
void digitalClockDisplay()
{
  //sprintf(sptext,"%0.2d:%0.2d:%0.2d",hour(),minute(),second());
 sprintf(sptext,"%0.2d:%0.2d:%0.2d %0.2d:%0.2d:%0.4d",hour(),minute(),second(),day() ,month() ,year() );
 Tekstprintln(sptext);
}
                         #endif DCFMOD
/*
void digitalClockDisplay()
{
//digital clock display of the time
  Serial.print(hour());
  printDigits(minute());
  printDigits(second());
  Serial.print(F(" "));
  Serial.print(day());
  Serial.print(F(" "));
  Serial.print(month());
  Serial.print(F(" "));
  Serial.print(year()); 
  Serial.println(); 
}
//--------------------------------------------
// DCF77 utility function prints preceding colon and leading 0
//--------------------------------------------
void printDigits(int digits)
{
  Serial.print(F(":"));
  if(digits < 10)
    Serial.print(F("0"));
  Serial.print(digits);
}                       #endif DCFMOD
*/                         
//--------------------------------------------
// DS3231 Set time in module and print it
//--------------------------------------------
void SetRTCTime(void)
{ 
 Ihour   = constrain(Ihour  , 0,24);
 Iminute = constrain(Iminute, 0,59); 
 Isecond = constrain(Isecond, 0,59); 
 RTC.adjust(DateTime(Inow.year(), Inow.month(), Inow.day(), Ihour, Iminute, Isecond));
 GetTijd(0);                               // synchronize time with RTC clock
 Displaytime();
 Print_tijd();
}
//--------------------------------------------
// DS3231 Get temperature from module
//--------------------------------------------
int get3231Temp(void)
{
 byte tMSB, tLSB;
 int temp3231;
  
  Wire.beginTransmission(DS3231_I2C_ADDRESS);    //temp registers (11h-12h) get updated automatically every 64s
  Wire.write(0x11);
  Wire.endTransmission();
  Wire.requestFrom(DS3231_I2C_ADDRESS, 2);
 
  if(Wire.available()) 
  {
    tMSB = Wire.read();                          //2's complement int portion
    tLSB = Wire.read();                          //fraction portion 
    temp3231 = (tMSB & B01111111);               //do 2's math on Tmsb
    temp3231 += ( (tLSB >> 6) * 0.25 ) + 0.5;    //only care about bits 7 & 8 and add 0.5 to round off to integer   
  }
  else {  temp3231 = -273; }   
  return (temp3231);
}

// --------------------Light functions -----------------------------------
//--------------------------------------------
//  LED Set colour for LED
//--------------------------------------------
void ColourLeds(int FirstLed, int LastLed, uint32_t RGBColor)
{
 int n;
 for (n = FirstLed; n <= LastLed; n++) {RGBstrip.setRGB(n,RGBColor); }
}

//--------------------------------------------
//  LED Clear display settings of the LED's
//--------------------------------------------
void LedsOff(void) 
{ 
 int n;
 for (n = 0; n <= NUM_LEDS; n++)
   {
    //  strip.setPixelColor(n,0);
      RGBstrip.setRGB(n,0);
   }
//  FastLED.clear();
}
//--------------------------------------------
//  LED Turn On the LED's
//--------------------------------------------
void WriteLEDs(void) 
{ 
  ShowLeds();    //Push data in LED strip to commit the changes
}
//--------------------------------------------
//  LED Turn On en Off the LED's
//--------------------------------------------
void Laatzien()
{ 
  WriteLEDs();
  delay(Delaytime);
  LedsOff(); 
}

//--------------------------------------------
//  LED Push data in LED strip to commit the changes
//--------------------------------------------
void ShowLeds(void)
{
   RGBstrip.sync();
}
//--------------------------------------------
//  LED Set brighness of LEDs
//--------------------------------------------  
void SetBrightnessLeds( byte Bright)
{
 RGBstrip.setBrightness(Bright);
 RGBstrip.sync();
}

//--------------------------------------------
//  LED function to make RGB color
//-------------------------------------------- 
uint32_t FuncCRGB(uint32_t Red, uint32_t Green, uint32_t Blue)
{
return (256*256 * Red + 256 * Green + Blue);
}

//--------------------------------------------
//  LED Set display colors of clock
//-------------------------------------------- 
void CheckColourStatus(void)
{
 if (DisplayChoice == DEFAULTCOLOUR) { Color = DefaultColor;      }   
 if (DisplayChoice == NOFUSSCOLOUR ) { Color = WhiteColour;     MINColor = WhiteColour;  SECColor = WhiteColour;    }  // all white
 if (DisplayChoice == HOURLYCOLOUR ) { Color = HourColor[Ihour];   }                           // A colour every hour
 if (DisplayChoice == DEMOCOLOUR )   { MINColor = WhiteColour;  SECColor = WhiteColour;  Color = WhiteColour;  }   // all white 
}
//--------------------------------------------
//  LED Set minute color
//--------------------------------------------
void SetMinuteColour()                                 // Set the colour per minute of 'HET'
{
 MINColor = FuncCRGB(15 + (Iminute * 4),   255 - Iminute * 4, 0);  
}
//--------------------------------------------
//  LED Set second color
//--------------------------------------------
void SetSecondColour()                                 // Set the colour per second of 'IS' and 'WAS'
{
 byte Bluecolor=0 ;
 if(Is)
 {
  if (Iminute%5==0) SECColor = Color;
  SECColor = FuncCRGB(15 + (Isecond + ((Iminute + 1)%5)*90),   255 - (Isecond + ((Iminute + 1)%5)*90), Bluecolor);
  }
 else SECColor = FuncCRGB(15 + (Isecond*2 + ((Iminute + 3)%5)*120),   255 - (Isecond*2 + ((Iminute + 3)%5)*120), 0);
}

//--------------------------------------------
//  LED Dim the leds by PWM measured by the LDR and print values
//--------------------------------------------
void DimLeds(byte print) 
{                                                                                                       
 if (SecPulse) 
 {
  int LDR_read = analogRead(PhotoCellPin);      // Read lightsensor
  OutPhotocell = (int) (LightReducer * sqrt( (float) 63.5 * (float) constrain(LDR_read,1,1023))); // Linear --> hyperbolic with sqrt
  MinPhotocell = MinPhotocell > LDR_read ? LDR_read : MinPhotocell;
  MaxPhotocell = MaxPhotocell < LDR_read ? LDR_read : MaxPhotocell;
  BrightnessCalcFromLDR = constrain(OutPhotocell, LowerBrightness , 255);                   // filter out of strange results
  
  if(print)
  {
 sprintf(sptext,"Sensor:%3ld%",(long)(analogRead(PhotoCellPin)));
 Tekstprint(sptext);
 sprintf(sptext," Min:%3ld%",(long)(MinPhotocell));
 Tekstprint(sptext);
 sprintf(sptext," Max:%3ld%",(long)(MaxPhotocell));
 Tekstprint(sptext);
 sprintf(sptext," Out:%3ld",(long)(OutPhotocell));
 Tekstprint(sptext);
 sprintf(sptext,"=%2ld%%",(long)(BrightnessCalcFromLDR/2.55));
 Tekstprint(sptext);
 sprintf(sptext," Temp:%2ldC ",(long) get3231Temp());
 Tekstprintln(sptext);
    
//   Serial.print(F("SensorRead: "));       Serial.print(LDR_read);
//   Serial.print(F(" Min: "));             Serial.print(MinPhotocell);  
//   Serial.print(F(" Max: "));             Serial.print(MaxPhotocell);  
//   Serial.print(F(" Max brightness: "));  Serial.print((int) (LightReducer * 100));     
//   Serial.print(F("% Out: "));            Serial.print(OutPhotocell);  
//   Serial.print(F(" = "));                Serial.print(( int) (BrightnessCalcFromLDR/2.55));   
//   Serial.print(F("% Temp: "));           Serial.print(get3231Temp());   Serial.print(F("C "));  
   Print_tijd();
  }
  analogWrite(PWMpin, BrightnessCalcFromLDR);  // write PWM 
  SetBrightnessLeds(BrightnessCalcFromLDR);  
 }
 SecPulse = 0;
}

//--------------------------------------------
//  LED Turn On en Off the LED's
//--------------------------------------------
void Play_Lights()
{
  for (int n=0; n<24; n++) 
  {
    for (int i=0; i<NUM_LEDS; i++) { ColourLeds(i,i,HourColor[n]); }
   ShowLeds();    // FastLED.show();
    delay(60);  
  }
  SetBrightnessLeds(BRIGHTNESS);  //LEDS.setBrightness(BRIGHTNESS);
  LedsOff();
}

void ChangePalettePeriodically()
{
  SetBrightnessLeds(BRIGHTNESS);
}

//--------------------------------------------
//  LED In- or decrease light intensity value
//--------------------------------------------
void WriteLightReducer(float amount)
{
 LightReducer += amount; 
 WriteLightReducerEeprom(LightReducer);
}

//--------------------------------------------
//  LED Write light intensity to EEPROM
//--------------------------------------------
void WriteLightReducerEeprom(float value)
{
 LightReducer = value;
 if (LightReducer < 0.01 ) LightReducer = 0.01;
 if (LightReducer > 2.50 ) LightReducer = 2.50;                      // May not be larger than 2.55 (value*100 = stored as byte 
 EEPROM.write(0, (int) (LightReducer * 100));                        // Store the value (0-250) in permanent EEPROM memory at address 0
 sprintf(sptext,"Max brightness: %3ld%%",(long)(LightReducer*100)) ;
 Tekstprintln(sptext);
}

//--------------------------------------------
//  LED Write lowest allowable light intensity to EEPROM
//--------------------------------------------
void WriteLowerBrightness(int LowerBrightness)
{
 if (LowerBrightness < 1 ) LowerBrightness =  1;                     // Range between 1 and 100
 if (LowerBrightness > 255) LowerBrightness = 255;
 EEPROM.write(1, LowerBrightness);                                   // Default Lower Brightness for this clock
 sprintf(sptext,"Lower brightness: %3ld bits",(long) LowerBrightness);
 Tekstprintln(sptext);
}

// --------------------End Light functions 

//--------------------------------------------
//  CLOCK Input from Bluetooth or Serial
//--------------------------------------------
void ReworkInputString(String InputString)
{
 String temp;
 float ff;
 Serial.println(InputString);
 if ( InputString[0] > 64 )
  {
  int val = InputString[0];
  int FMfreq;
  switch (val)
   {
    case 'A':
    case 'a':   
             Toggle_HetWasIsUit = 0; Toggle_HetWasIs = 1;             // All tekst displayed  
             break;
    case 'B':
    case 'b':    
             Toggle_HetWasIsUit = 1; Toggle_HetWasIs = 0;             // Het Is Was turned off
             Serial.println(F("Het Is Was turned off"));
             break;
    case 'C':
    case 'c':    
            Toggle_HetWasIsUit = 2; Toggle_HetWasIs = 0;              // Het Is Was Off after 10 sec
            Play_Lights();                                               
            break;
    case 'D':
    case 'd':    
            Demo = 1 - Demo;                                          // toggle Demo mode
            Play_Lights();
            GetTijd(0);  
            Displaytime();
            break;
    case 'L':                                                         // Lowest value for Brightness
    case 'l':    
             temp = InputString.substring(1);
             LowerBrightness = temp.toInt();
             WriteLowerBrightness(LowerBrightness);
             break;                       
            
    case 'M':                                                         // factor ( 0 - 1) to multiply brighness (0 - 255) with 
    case 'm':    
             temp = InputString.substring(1);
             ff = (float)(temp.toInt()) / 100;
             WriteLightReducerEeprom(ff);
             break;
    case 'P':
    case 'p':
             temp = InputString.substring(1);
             DisplayPalette = temp.toInt();
            break;
    case 'I':
    case 'i':   
            SWversion();
            break;    
    default:
            break;
   }
   Displaytime();
   InputString = "";
 }
 else if (InputString.length() > 3 && InputString.length() <7 )
 {
  temp = InputString.substring(0,2);   
  Ihour = temp.toInt(); 
  if (InputString.length() > 3) { temp = InputString.substring(2,4); Iminute = temp.toInt(); }
  if (InputString.length() > 5) { temp = InputString.substring(4,6); Isecond = temp.toInt(); }
  SetRTCTime();
 }
 InputString = "";
 temp = "";
}
